
package de.ivu.elect.presentation.staat;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.staat.boundary.StaatConversationStore;
import de.ivu.elect.business.staat.boundary.StaatExtendedDAO;
import de.ivu.elect.business.staat.boundary.StaatEdit;
import de.ivu.elect.business.staat.entity.Staat;
import de.ivu.elect.business.staat.entity.StaatMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractStaatEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractStaatEditNoScopeView.VIEW_ID, useCase = UseCasePermission.STAAT_EDIT)
public abstract class AbstractStaatEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<Staat>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "staatEditView";

  public static final String VIEW_ID = "/staat/staat-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/staat/staat-search.xhtml";

  @Inject
  protected transient StaatExtendedDAO extendedDAO;

  @Inject
  protected transient StaatEdit edit;

  @Inject
  @ConversationGroup(StaatConversationStore.class)
  protected transient StaatConversationStore conversationStore;

  @Inject
  protected transient StaatMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient StaatEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public Staat getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(Staat entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.STAAT_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(Staat entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.STAAT_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.STAAT_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.STAAT_EDIT)
  @Override
  public String save() {
    Staat entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Staat entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    Staat entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(Staat entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.STAAT_EDIT);
  }
  
  @Redirect
  public String edit(Staat entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class StaatEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<Staat,   de.ivu.elect.business.staat.entity.StaatPK  > {

    private static final long serialVersionUID = 1L;
  }
}
